/* ###################################################################
**     Filename    : main.c
**     Project     : Test_PEnFNET
**     Processor   : MK64FN1M0VLL12
**     Version     : Driver 01.01
**     Compiler    : GNU C Compiler
**     Date/Time   : 2015-06-02, 23:09, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
** ###################################################################*/
/*!
** @file main.c
** @version 01.01
** @brief
**         Main module.
**         This module contains user's application code.
*/         
/*!
**  @addtogroup main_module main module documentation
**  @{
*/         
/* MODULE main */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "Pins1.h"
#include "INT_PIT3.h"
#include "INT_ENET_Receive.h"
/* Including shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "PDD_Includes.h"
#include "Init_Config.h"
/* User includes (#include below this line is not maintained by Processor Expert) */
#include "fnet.h"
#include "fnet_cpu.h"
/*
** ===================================================================
**     Event       :  Eth_task (module mqx_tasks)
**
**     Component   :  Tsk_Eth [MQXLite_task]
**     Description :
**         MQX task routine. The routine is generated into mqx_tasks.c
**         file.
**     Parameters  :
**         NAME            - DESCRIPTION
**         task_init_data  -
**     Returns     : Nothing
** ===================================================================
*/
#define ETH_P_TEST      0x1234
fnet_netif_desc_t fapp_default_netif; /* Default netif. */

static void fapp_dup_ip_handler( fnet_netif_desc_t netif )
{
    char name[FNET_NETIF_NAMELEN];
    char ip_str[FNET_IP4_ADDR_STR_SIZE];
    fnet_ip4_addr_t addr;

    fnet_netif_get_name( netif, name, FNET_NETIF_NAMELEN );
    addr = fnet_netif_get_ip4_addr( netif );
    fnet_inet_ntoa(*(struct in_addr *)( &addr), ip_str);

}

static void fapp_init(void)
{
    static unsigned char stack_heap[FNET_CFG_HEAP_SIZE];
    struct fnet_init_params init_params;


    /* Input parameters for FNET stack initialization */
    init_params.netheap_ptr = stack_heap;
    init_params.netheap_size = (unsigned long)FNET_CFG_HEAP_SIZE;


    /* Add event handler on duplicated IP address */
#if FNET_CFG_IP4
    fnet_netif_dupip_handler_init(fapp_dup_ip_handler);
#endif

    /* Init FNET stack */
    if(fnet_init(&init_params) != FNET_ERR)
    {
        if((fapp_default_netif = fnet_netif_get_default()) == FNET_NULL)
        {

        }
    }
}


extern void init_data_bss(void);

/*lint -save  -e970 Disable MISRA rule (6.3) checking. */
int main(void)
/*lint -restore Enable MISRA rule (6.3) checking. */
{
  /* Write your local variable definition here */
	SOCKET mySocket;
	struct sockaddr  sSll;     /* Socket address */
	int counter = 0;
	char cBuffer[8];
	int sentDataLength;

	/*
    SIM_SCGC5 |= (SIM_SCGC5_PORTA_MASK
                  | SIM_SCGC5_PORTB_MASK
                  | SIM_SCGC5_PORTC_MASK
                  | SIM_SCGC5_PORTD_MASK
                  | SIM_SCGC5_PORTE_MASK
                  );*/

	SIM_SCGC5 |= (SIM_SCGC5_PORTC_MASK | SIM_SCGC5_PORTA_MASK | SIM_SCGC5_PORTB_MASK);

	fapp_init();

	mySocket = socket(AF_SUPPORTED,SOCK_RAW,FNET_HTONS(ETH_P_TEST));
	setsockopt(mySocket, SOL_SOCKET, SO_KEEPALIVE, 0, 0);

	memset(&sSll, 0, sizeof(sSll));
	sSll.sa_family = AF_SUPPORTED;            /* Low level packet interface */
	sSll.sa_data[0] = 1;
	sSll.sa_port = 1;

	while(1)
	{
		counter++;
		sentDataLength = sendto( mySocket, (void*)&cBuffer[0], 8, 0, (struct sockaddr *)&sSll, sizeof(struct sockaddr));
	}


  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/

  /* Write your code here */
  /* For example: for(;;) { } */

  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** RTOS startup code. Macro PEX_RTOS_START is defined by the RTOS component. DON'T MODIFY THIS CODE!!! ***/
  #ifdef PEX_RTOS_START
    PEX_RTOS_START();                  /* Startup of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /*** End of RTOS startup code.  ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END main */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.5 [05.21]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
